#pragma once

#include "Image.h"

#include <memory>
#include <string>
#include <filesystem>

using Path = std::filesystem::path;

class PngWriter
{
public:
    PngWriter();

    static std::unique_ptr<PngWriter> Create();

    void setPath(const Path& path);

    void write(const std::unique_ptr<Image<unsigned char> >& image) const;

private:
    Path mPath;
};

using PngWriterPtr = std::unique_ptr<PngWriter>;
